; miron63,.
;  RC0  RC7  (58,60,68,70)   
;
;	   ESR  
;                C/ESR meter
;		 
;		1.01
;	 	20/04/2007
;
;	      FLC
;	 , ., 

;	    PIC16F873A
;***************************************************************************************
;* *             *   
;***************************************************************************************

; 1    *  MCLR/Vpp         *  
; 2    *  RA0/AN0          *    (=330)
; 3    *  RA1/AN1          *    (=33)
; 4    *  RA2/AN2/Vref-    *  . Set coeff./Set "0"
; 5    *  RA3/AN3/Vref+    *
; 6    *  RA4/T0CKI        *  .+/Test
; 7    *  RA5/AN4/SS       *  .-
; 8    *  Vss              * GND
; 9    *  OSC1/CLKIN       *  20 
; 10   *  OSC2/CLKOUT      *  20 
; 11   *  RC0/T1OSO/T1CKI  *  , I=10mA
; 12   *  RC1/T1OSI/CCP2   *  
; 13   *  RC2/CCP1         *     
; 14   *  RC3/SCK/SCL      * ."-"  

; 15   *  RC4/SDI/SDA      * ."+"  
; 16   *  RC5/SDO          * ."-"  
; 17   *  RC6/TX/CK        *     
; 18   *  RC7/RX/DT        *
; 19   *  Vss              * +5V
; 20   *  Vdd              * GND
; 21   *  RB0/INT          * LCD_D4
; 22   *  RB1              * LCD_D5
; 23   *  RB2              * LCD_D6
; 24   *  RB3/PGM          * LCD_D7
; 25   *  RB4              * LCD_R/S
; 26   *  RB5              * LCD_E
; 27   *  RB6/PGC          *
; 28   *  RB7/PGD          *

;****************************************************************************************

Port_A_Config	equ 0xFF
; Port A bit equates
Kn_Set  		equ	2
Kn_Plus  		equ 4
Kn_Minus  		equ 5

Port_B_Config	        equ b'00000000'	;**************************

Port_C_Config	        equ b'01000101'	; RC0 RC7****************
; Port C bit equates
Cap_Charge  	        equ 7		; RC0 RC7****************
Cap_Discharge	equ 1
Comp_Up			equ 2
In_N_Gnd		equ 3
In_P_Cx			equ 4
In_N_Cx			equ 5
Comp_Low		equ 6

ESR_ready		equ	b'10110010'     ;. , "+"  "-"   	; RC0 RC7***********************
ESR_start		equ b'00110000'	;. , "+"  "-"   
Cap_ready		equ     b'10011010'	;. , "-"   , "+"  ; RC0 RC7***********************
Cap_start		equ	b'00011000'	;. , "-"   , "+"  
Cap_start2		equ	b'00110000'	;. , "-"   Cx, "+"  

Max_Count		equ	.70	;  (1 ,   256)  TMR0  
						;  - 0.2 , 65536*0.2=13107.2  -  
						;  I=10mA 15 / 65536/15=4369  -  
						;  =150000, 150000/4369=34
						;        
;****************************************************************************************


	 list      p=PIC16F873a
     #include  P16F873a.inc ;	; 20.000 MHz
	__CONFIG _CP_OFF & _BODEN_OFF & _HS_OSC & _WRT_OFF & _WDT_OFF & _PWRTE_ON & _DEBUG_OFF & _CPD_OFF & _LVP_OFF

;	#define	_BAT	PORTA,1		; 0- low bat

	#define	_RS	    PORTB,4
	#define	_E	    PORTB,5


	CBLOCK 0x35 ;0x20-0x34 for FLOATING POINT LIBRARY
	;--------------	  ESR --------------------
	W_TEMP		;   
	STATUS_TEMP
	PCLATH_TEMP
	

	Dly0  ;Stores 3 bytes of data for the delay count
	Dly1  ;Dly0 is the least significant byte
	Dly2  ;while Dly3 is the most significant byte

	Temp
	Temp1
	Temp2
	Temp3
	Temp4

	Count1
	Count2

	T0
	T1

	;	 
	T2	;  
	T3
	T4
	T5	;  

	AX	;  
	A0
	A1
	A2	;  

	A3
	A4
	A5

	BCD0	;  
	BCD1
	BCD2
	BCD3
	BCD4	;  
	
	U330_L	;   , =330,  
	U330_H	;   , =330,  
	U33_L	;   , =33,  
	U33_H	;   , =33,  
	
	TMR1_Count	;  TMR1
	TMR0_Count	;  TMR0
	Flags
	EE_ADR    ;     EEPROM
	EE_DATA
	NZ	  ;      
	NC	  ; 
	Const_ADR ;   EEPROM
;************  *****************************
;************  LC_metr     *****************************

        Flag_F

        REGA0				;lsb
        REGA1
        REGA2
        REGA3				;msb

        REGB0				;lsb
        REGB1
        REGB2
        REGB3				;msb

        REGC0				;lsb
        REGC1
        REGC2
        REGC3				;msb

	DSIGN				;Digit Sign. 0=positive,1=negative
	DIGIT1				;MSD
	DIGIT2
	DIGIT3
	DIGIT4
	DIGIT5				;Decimal (BCD) digits
	DIGIT6
	DIGIT7
	DIGIT8
	DIGIT9
	DIGIT10	

        MTEMP
        MCOUNT
        DCOUNT
                FrHig1
                FrLow1	
                       ;ENDC
	ENDC
	
	CBLOCK 0xB5
	W_TEMP1		;   
	ENDC
;************  TEST *****************************
 
	#define Horz	PORTB,3
     		CBLOCK     0x20
     	
	Count3
 	Count4     	
	Blanc		      
	Jaune		     
	Cyan	          
	Vert		      
	Magenta	      
	Rouge		    
	Bleu		      
	  ENDC
	
;=========================
;       
;=========================
bank0	macro 
	    bcf STATUS, RP0
    	endm
	
bank1	macro 
	    bsf STATUS, RP0
    	endm	

Dly24 MACRO DLY
;Take the delay value argument from the macro, precalculate
;the required 3 RAM values and load the The RAM values Dly2,Dly1 
;and Dly0.
	banksel Dly0
	movlw   DLY & H'FF'
	movwf   Dly0
	movlw   DLY >>D'08' & H'FF'
	movwf   Dly1
	movlw   DLY >>D'16' & H'FF'
	movwf   Dly2
;Bytes are shifted and anded by the assembler to make user 
;calculations easier.
	endm
	
;==========================
	
	ORG		0x2100   	;  EEPROM
;					; 	 EEPROM

;   :
USR_1		DE	0x00, 0x00, 0x03, 0xE8	; 1 -  1 
USR_10		DE	0x00, 0x00, 0x03, 0xE8	; 1 -  10 
USR_Cx		DE	0x00, 0x00, 0x03, 0xE8	; 1 -  


;numbers in FLOATING POINT LIBRARY format
U0_ESR_1	DE	0x85, 0x16, 0x00, 0x00 ; 75=85160000 - "0"   1 
U0_ESR_10	DE	0x81, 0x60, 0x00, 0x00 ;  7=81600000 - "0"   10 

;   :
M_ESR_1		DE	0x75, 0x40, 0x30, 0x0C ; 1/682=7540300C
M_ESR_10	DE	0x78, 0x74, 0x89, 0x8D ; 1/67=7874898D
M_Cx		DE	0x74, 0x2E, 0xC3, 0x3E ; 1/(15*100)=742EC33E
sub_Cx		DE	0x80, 0x40, 0x00, 0x00 ; 3=80400000 -    TMR1
;*********************************************************************************************
;    Lx---
C_Lx		DE	0x02, 0x8A, 0x00, 0x00 ; 0x24,0x25
;    Lx---*10
L_Lx		DE	0x27, 0x10, 0x00, 0x00 ; 0x28,0x29
;*********************************************************************************************
;     Cx---*10
C_Cx		DE	0x19, 0x64, 0x00, 0x00 ; 0x2C,0x2D
;*********************************************************************************************
;
;		   +0x00 -0x02, 	    ,		
CH_EE1   	  	DE  0x00,   0x80,  0xF0,    0xFA ,   0x02,   0x00,  0x00,   0x00   ;

CH_EE2   	      DE  0x02,   0x07,  0x06,    0xAA,    0x14,   0x00,  0x00,   0x00   ;

CH_EE3            DE  0x00,   0x06,  0x05,    0xAA,    0x12,   0x00,  0x00,   0x00   ;
       
CH_EE4   	      DE  0x02,   0x05,  0x0A,    0xAA,    0x14,   0x00,  0x00,   0x00   ;
               
;==========================
;==========================
		org 	0x700 ;  256  1-   
Table	addwf	PCL,F
omega	dt	b'00000000'	; 
		dt	b'00001110'
		dt	b'00010001'
		dt	b'00010001'
		dt	b'00010001'
		dt	b'00001010'
		dt	b'00011011'
		dt	b'00000000'
		
mu		dt	b'00000000'
		dt	b'00000000'
		dt	b'00010010'
		dt	b'00010010'
		dt	b'00010010'
		dt	b'00011110'
		dt	b'00010001'
		dt	b'00010000'
_Const	dt	"Coe",0
_ESR	dt	"ESR",0
_Cx		dt	" Cx ",0
_Time_out	dt	"Cx ---",0
_1_ohm	dt	" 1 ",1,0
_10_ohm	dt	" 10 ",1,0
_tst_1	dt	"1",1,"=",0
_tst_10	dt	" 10",1,"=",0
_write_U0	dt	"U0 ---> EEPROM  ",0
_ready	dt	"It is ready!",0
;*********************************************************************
;*********************************************************************
_640	dt	" 640*480",0	;  VGA metr**************
_60	dt	"  60 Hz",0		;  VGA metr**************

;*******************************************************************************
;*******************************************************************************

		org 	0x00 
;*******************************************************************************
;                              
;******************************************************************************* 	
		nop			;for MPLAB-ICD2
		goto		init
;------------------ Interrupt ------------------
		org		0x004

		movwf   W_TEMP		;save W
		swapf   STATUS,W	;swap STATUS, W
		clrf	STATUS
		movwf   STATUS_TEMP	;save status
		movf	PCLATH,W
		movwf	PCLATH_TEMP	;save PCLFTH
		
		decfsz	TMR0_Count
		goto	restore_context
		bsf		Flags,0		;Time Out!
		goto	stop_TMR1
		
restore_context
		bcf     INTCON,T0IF	;clear interrupt flag
		
		movf	PCLATH_TEMP,W
		movwf	PCLATH
		swapf	STATUS_TEMP,W	;fetch status, reswap nibbles
		movwf   STATUS			;restore status
		swapf   W_TEMP,F    ;swap nibbles in preparation
		swapf   W_TEMP,W    ;for the swap restoration of w
		retfie				;return from interrupt
;-----------------------------------------------

init
		banksel		INTCON
		clrf		Flags
		clrf		INTCON
		clrf		PCLATH
		clrf		PORTA
		clrf		PORTB
		movlw		ESR_ready ;. , "+"  "-"   
		movwf		PORTC

		banksel		TRISA
		movlw		Port_A_Config
		movwf		TRISA
		; 
		movlw		b'10000100'; , Vdd, Vss, AN0, AN1, AN3
		movwf		ADCON1

		movlw		Port_B_Config
		movwf		TRISB
		movlw		Port_C_Config
		movwf		TRISC

;	 LCD  4-  		
InitLCD
        call		Delay_5_ms
        call		Delay_5_ms
        call		Delay_5_ms      ; 15    
		banksel		PORTB
		movlw		3
		movwf		Count1
		movwf		PORTB
SetLoop
        bsf		_E		;  LCD 3    0x30
		nop
		nop
		nop
		bcf		_E
		call		Delay_5_ms
		decfsz		Count1,f
		goto		SetLoop
		
		movlw		2		; 4-x 
		movwf		PORTB
		call		Send
		movlw		28		; 4- , 2 , 57
		call		CmdLCD
		movlw		0C		;  
		call		CmdLCD
		movlw		6
		call		CmdLCD
		call		Load_ZG ;     
        call		ClrDSP		;  
;--------------------------------------------------
		btfsc		PORTA, Kn_Set ;
		goto		Main
;------------    ------------
		goto		c_1		
Const_Loop
		btfss		PORTA, Kn_Plus
		call		IncB
		btfss		PORTA, Kn_Minus
		call		DecB
		btfsc		PORTA, Kn_Set
		goto		Const_Loop

		btfss		Flags,5	;  
		goto		c_3
		call		Save_Const	; ,  		
c_3
		incf		NC,F
		movf		NC,W
		sublw		3	; 
		btfss		STATUS,Z
		goto		$+2
c_1		clrf		NC
		bcf			Flags,5	;   
        call		ClrDSP		;  
   		movlw		LOW _Const
		call		Read_String
		movlw 		HIGH $
		movwf 		PCLATH
        movf		NC,W
        addwf		PCL,F ; 
        goto		const_1_ohm		;+0
        goto		const_10_ohm	;+1
        goto		const_Cx		;+2
c_2		call		ShowX
        goto		Const_Loop

const_1_ohm
		movlw		LOW USR_1
		movwf		Const_ADR
		call		EEPROM_To_B
		movlw		LOW _1_ohm
		call		Read_String
		goto		c_2
const_10_ohm
		movlw		LOW USR_10
		movwf		Const_ADR
		call		EEPROM_To_B
		movlw		LOW _10_ohm
		call		Read_String
		goto		c_2
const_Cx		
		movlw		LOW USR_Cx
		movwf		Const_ADR
		call		EEPROM_To_B
		movlw		LOW _Cx
		call		Read_String
		goto		c_2
;-------    ------
Main
;		banksel		ADCON1
;		movlw		b'10000100'; , Vdd, Vss, AN0, AN1, AN3
;		movwf		ADCON1

ESR_measure
		banksel		PORTC
		movlw		ESR_start ; . , "+"  "-"   
		movwf		PORTC
		
		movlw		0x4		; 3.6 (18 )   . - !!!
		call		Delay_go

		bcf			PORTC, In_P_Cx ;   
		nop			;???
		bsf			PORTC, Cap_Charge ;. I.

		;    .  =330
		banksel		ADCON0
		movlw		b'10000001' ;Fosc/32,  0,   .
		movwf		ADCON0
		call		Delay_20_us
		bsf			ADCON0,2	; - 
		btfsc		ADCON0,2
		goto		$-1		;   
		movf		ADRESH,W
		movwf		U330_H
		banksel		ADRESL
		movf		ADRESL,W
		banksel		U330_L
		movwf		U330_L
		
		;    .  =33
		banksel		ADCON0
		movlw		b'10001001' ;Fosc/32,  1,   .
		movwf		ADCON0
		call		Delay_20_us
		bsf			ADCON0,2	; - 
		btfsc		ADCON0,2
		goto		$-1		;   
		movf		ADRESH,W
		movwf		U33_H
		banksel		ADRESL
		movf		ADRESL,W
		banksel		U33_L
		movwf		U33_L

;------------  ESR>10 ,     ------------
		clrf		Flags
		movlw		0x03
		subwf		U33_H,W	;  >=0x300 (768)
		btfss		STATUS,Z
		goto		Cx_0	;   
		bsf			Flags,0		;  Time Out
;************** *******
;**************************************
	btfsc		PORTA,Kn_Set       ;*
	goto		$+2                ;*
           	goto	VGA	             ;*	
;**************************************

		goto		Cx_3
;------------    ------------
Cx_0
		movlw		Cap_ready ;. , "-"   , "+"  
		movwf		PORTC
		call		TMR0_init	; TMR0      
		
		call		Delay_200_us
		btfss		PORTC, Comp_Low	; 1 - Cx 
		goto		$-2				;  200 
		call		Delay_200_us	;   
		call		TMR1_init

		movlw		0x03
		subwf		U330_H,W	;  >=0x300 (768)
		btfss		STATUS,Z	;.. ESR>1 ,     ESR
		goto		Cx_1
		movlw		Cap_start2	;. , "-"   Cx, "+"  
		movwf		PORTC
		movlw		0x4		; 3.6 (18 )     "-"  
		call		Delay_go
		bcf			PORTC,In_N_Cx	; "-"    
		goto		Cx_2
Cx_1
		movlw		Cap_start ;. , "-"   , "+"  
		movwf		PORTC
Cx_2		
		btfsc		PORTC, Comp_Low ; 0 - Cx    
		goto		$-1
		bsf			T1CON, TMR1ON	;  

tst_charge
		btfss		PORTC,Comp_Up; 0 - Cx    
		goto		stop_TMR1
		btfsc		PIR1, TMR1IF	; TMR1 ?
		call		Inc_count
		goto		tst_charge

stop_TMR1
		clrf		T1CON	; TMR1
		clrf		INTCON	; 
		btfsc		PIR1, TMR1IF	;     
		call		Inc_count		; 
Cx_3	movlw		Cap_ready ;. , "-"   , "+"  
		movwf		PORTC

;--------------------------------------------------------
;   
;		call		CursorHome
		call		ClrDSP
;Timeout		
		btfss		Flags,0
		goto		Disp_Cx
		movlw		LOW _Time_out
		call		Read_String
		goto		Disp_ESR

;--------------------------------------------------------
		clrf		FPFLAGS
		bsf			FPFLAGS, RND ;    
Disp_Cx
		movlw		LOW _Cx
		call		Read_String

		clrf		AEXP
		movf		TMR1_Count,W
		movwf		AARGB0
		movf		TMR1H,W
		movwf		AARGB1
		movf		TMR1L,W
		movwf		AARGB2
		
		btfsc		PORTA, Kn_Plus
		goto		Calc_Cx
		call		BCD 	;   ,   
		movlw		BCD4	;  
		call		Disp_Full
		goto		Disp_ESR
Calc_Cx		
		call		FLO2424 ;Integer to float conversion
		movlw		low sub_Cx
		call		EEPROM_To_B
		call		FPS24	;A=A-3
		movlw		low M_Cx
		call		EEPROM_To_B
		call		FPM24	;A=A*M_Cx
		movlw		low USR_Cx
		call		X_To_B
		call		INT2424	;Output: 24 bit 2's complement integer right
							;justified in AARGB0, AARGB1, AARGB2
		clrf		AEXP
		call		BCD
		bsf			Flags,1 ;   
		movlw		3
		movwf		NZ		;  ,   0
		bsf			Flags,3	;  .   
				
		movlw		BCD3
		call		DispBCD
		movlw		BCD3	;   10 ,
		call		DispBCD	;    	
		
		movlw		BCD2	;  
		call		DispBCD
		movlw		BCD2	; 
		call		DispBCD

		;     ,   
		btfsc		Flags,1
		goto		next_1
		movlw		","		; 
		call		CharLCD
next_1
		movlw		BCD1	; 
		call		DispBCD
		btfsc		Flags,1 ;    ,
		bsf			Flags,2	;    
		movlw		BCD1	; 
		call		DispBCD

		bcf			Flags,1	;  =0  ,   
		movlw		BCD0	; 
		call		DispBCD
		
		btfss		Flags,2 ;    
		goto		next_2  ;
		bcf			Flags,2	;
		call		DispDot	; 
		movlw		BCD0	; 
		call		DispBCD
next_2
		call		DispSP
		movlw		2		; 
		call		CharLCD
		movlw		"F"
		call		CharLCD
;----------------------------
Disp_ESR
		btfss		PORTA, Kn_Plus
		goto		tst_ESR
		
		bcf			Flags,4 ;   10 		
		movlw		0x03
		subwf		U330_H,W	;  >=0x300 (768)
		btfsc		STATUS,Z	;   (10 )
		goto		chk_10
		
;  1 
		call		ClrA
		movf		U330_H,W ; =330,  1 
		movwf		AARGB0
		movf		U330_L,W
		movwf		AARGB1
		call		FLO1624 ;to 24 bit floating point
		movlw		low U0_ESR_1
		call		EEPROM_To_B
		call		FPS24	;A=A-U0 -   
		movlw		low M_ESR_1
		call		EEPROM_To_B
		call		FPM24	;A=A*M_ESR_1
		movlw		low USR_1
		call		X_To_B
		goto		ESR_to_LCD

chk_10
		movlw		0x03
		subwf		U33_H,W	;  >=0x300 (768)
		btfsc		STATUS,Z
		bsf			Flags,4 ; 10 		

; 10 
		call		ClrA
		movf		U33_H,W ; =33,  10 
		movwf		AARGB0
		movf		U33_L,W
		movwf		AARGB1
		call		FLO1624 ;to 24 bit floating point
		movlw		low U0_ESR_10
		call		EEPROM_To_B
		call		FPS24	;A=A-U0 -   
		movlw		low M_ESR_10
		call		EEPROM_To_B
		call		FPM24	;A=A*M_ESR_10
		movlw		low USR_10
		call		X_To_B

ESR_to_LCD
		call		SecLine
		movlw		LOW _ESR
		call		Read_String
		
		btfss		Flags,4 ;>10 ohm?
		goto		next_3
		movlw		">"
		call		CharLCD
		goto		next_4
next_3	call		DispSP

next_4	movlw		0x80
		andwf		AARGB0,W ;  "-"
		btfsc		STATUS,Z
		goto		next_5	; > 0
		call		ClrA	; < 0,   
		goto		next_6
next_5	call		INT2424

next_6	bcf			Flags,3	;  .   
		bsf			Flags,1 ;   
		clrf		AEXP
		call		BCD

		movlw		BCD2
		call		DispBCD
		movlw		BCD2
		call		DispBCD ; 

		bcf			Flags,1	;  =0  ,   
		movlw		BCD1	; 
		call		DispBCD
		call		DispDot
		movlw		BCD1
		call		DispBCD

		movlw		BCD0
		call		DispBCD
		movlw		BCD0
		call		DispBCD
		
		call		DispSP
		movlw		1				; 
		call		CharLCD
end_disp
		banksel		PORTC
		bsf			PORTC, Cap_Discharge ;.  

		call		Delay_05_sec
		
		banksel		PORTC
		bcf			PORTC, Cap_Discharge ;.  
		
		goto	ESR_measure

;  -    
; 2-  (1  10 )
tst_ESR
		call		SecLine
		; 1 
		movlw		LOW _tst_1
		call		Read_String
		call		ClrA
		movf		U330_H,W ; =330,  1 
		movwf		AARGB1
		movf		U330_L,W
		movwf		AARGB2
		call		BCD
		movlw		BCD1
		call		Disp_Full
		; 10 
		movlw		LOW _tst_10
		call		Read_String
		call		ClrA
		movf		U33_H,W ; =33,  10 
		movwf		AARGB1
		movf		U33_L,W
		movwf		AARGB2
		call		BCD
		movlw		BCD1
		call		Disp_Full
		btfsc		PORTA, Kn_Set	;   
		goto		end_disp
		; U0  EEPROM ------------------------
		call		CursorHome
		movlw		LOW _write_U0
		call		Read_String
		;U0  l 
		call		ClrA
		movf		U330_H,W ; =330,  1 
		movwf		AARGB0
		movf		U330_L,W
		movwf		AARGB1
		call		FLO1624 ;to 24 bit floating point
		call		BEQUA
		movlw		LOW U0_ESR_1
		movwf		Const_ADR
		call		Save_Const
		;U0  l0 
		call		ClrA
		movf		U33_H,W ; =33,  10 
		movwf		AARGB0
		movf		U33_L,W
		movwf		AARGB1
		call		FLO1624 ;to 24 bit floating point
		call		BEQUA
		movlw		LOW U0_ESR_10
		movwf		Const_ADR
		call		Save_Const

		call		Delay_3_sec
		call		ClrDSP
		movlw		LOW _ready
		call		Read_String
		call		Delay_1_sec
		goto		end_disp
;------------------------- TMR1 -------------------------
;  TMR1,   = 0.2 
TMR1_init
		clrf		TMR1L
		clrf		TMR1H
		bcf			PIR1, TMR1IF
		movlw		b'00000000'; 1:1 Fosc/4
		movwf		T1CON
		clrf		TMR1_Count
		return
;------------------------- TMR1 -------------------------
;   TMR1
Inc_count
		bcf			PIR1, TMR1IF	;   
		incfsz		TMR1_Count,F
		return
		bsf			Flags,0	;Time out
		goto 		stop_TMR1;       
;------------------------- TMR0 -------------------------
;  TMR0,   = 0.2 
TMR0_init
		movlw	Max_Count
		movwf	TMR0_Count	;    TMR0
		clrf	TMR0	 ;clear timer
		movlw	OPTION_REG ;Work around the OPTION
		movwf   FSR		;address OPTION_REG -> FSR
		movlw	b'00000111' ; set up timer. 1:256 presc 
		movwf	INDF
		
		bcf	INTCON,T0IF	;clear tmr0 int flag
		bsf	INTCON,T0IE ;enable TMR0 int
		bsf	INTCON,GIE	;enable global interrupts
		clrf	TMR0	;start timer
		return
;------------------------- Delay -------------------------
;	 
Delay_3_sec		; 3 
		Dly24	D'937499'   ; 3/(4/20000000)/16=937500-1=937499
		goto	DoDly24

Delay_2_sec		; 2 
		Dly24	D'624999'   ; 2/(4/20000000)/16=625000-1=624999
		goto	DoDly24

Delay_1_sec		; 1 
		Dly24	D'312499'   ; 1/(4/20000000)/16=312500-1=312499
		goto	DoDly24

Delay_05_sec		; 0.5 
		Dly24	D'156249'   ; 0.5/(4/20000000)/16=156250-1=156249
		goto	DoDly24

Delay_5_ms	; 5 
		Dly24	D'1562'   ; 0.005/(4/20000000)/16=1562.5=1562
		goto	DoDly24
		
Delay_200_us	; 200 
		Dly24	D'62'   ; 0.0002/(4/20000000)/16=62.5=62
		goto	DoDly24

DoDly24		;16 Tcy per loop
		movlw   H'FF'      ;Start with -1 in W
		addwf   Dly0,F     ;LSB decrement
		btfsc   STATUS,C   ;was the carry flag set?
		clrw               ;If so, 0 is put in W
		addwf   Dly1,F     ;Else, we continue.
		btfsc   STATUS,C
		clrw               ;0 in W
		addwf   Dly2,F
		btfsc   STATUS,C
		clrw               ;0 in W
		iorwf   Dly0,W     ;Inclusive-OR all variables
		iorwf   Dly1,W     ;together to see if we have reached
		iorwf   Dly2,W     ;0 on all of them.
		btfss   STATUS,Z   ;Test if result of Inclusive-OR's is 0
		goto    DoDly24
		return

Delay_20_us
		movlw		0x1F		; 20 
Delay_go
		movwf		Dly0
		decfsz		Dly0,F
		goto		$-1
		nop
		nop
		return

;---------------------- LCD ---------------------
;	        
SecLine		movlw		0xC0

;	 
CmdLCD	movwf	Temp4
;		bcf		_RS
		swapf	Temp4, W
		andlw	0x0F
		movwf	PORTB
		bsf		_E
		nop
		nop
		nop
		bcf		_E
		movf	Temp4, W
		andlw	0x0F
		movwf	PORTB
		bsf		_E
		nop
		nop
		nop
		bcf		_E
;		clrf		PORTB
		call	Delay_200_us
		return


;	  ASCII  
NumLCD	andlw		0x0F		; 
		iorlw		0x30		; ASCII
;	 ASCII 
CharLCD	movwf		Temp4
SendLCD	swapf		Temp4, W
		andlw		0x0F
		iorlw		b'00010000'	; RS=1
		movwf		PORTB
		bsf		_E
		nop
		nop
		nop
		bcf		_E
		movf		Temp4, W
		andlw		0x0F
		iorlw		b'00010000'	; RS=1
		movwf		PORTB
Send	bsf		_E
		nop
		nop
		nop
		bcf		_E
		clrf		PORTB
		call		Delay_200_us
		return



CursorHome	movlw		0x02		;    
			goto		LongSend
ClrDSP		movlw		1		;  
LongSend	call		CmdLCD
			goto		Delay_5_ms

DispDot		movlw		"."
			goto		CharLCD

Disp0		movlw		"0"
			goto		CharLCD

DispSP		movlw		" "
			goto		CharLCD

;-----------------------------------------------------------
;       LCD
Read_String
			movwf		Count1
			decf		Count1,F ;  
			movlw 		HIGH Table
			movwf 		PCLATH
get_next_s
			movf		Count1,W
			call		Table
			andlw		0xFF	;    
			btfsc		STATUS, Z
			return
			call		CharLCD
			incf		Count1,F
 			goto		get_next_s

;---------------------- Load CGRAM LCD ---------------------
; 
Load_ZG
			movlw		b'01001000' ; AC in CGRAM=8
			call		CmdLCD
			movlw 		HIGH Table
			movwf 		PCLATH
			movlw		.16		;2   8 
			movwf		Count1
			movlw		LOW  omega-1
			movwf		Count2	;  

get_s		call		Table	;   
			call		CharLCD
			incf		Count2,F
			movf		Count2,W
			decfsz		Count1,F
			goto		get_s
			return
;----------------------------------------------------------
;    W   BCD0...4
; 
Disp_Full
			movwf		FSR		;     LCD
next_byte
			swapf		INDF,W
			call		NumLCD
			movf		INDF,W
			call		NumLCD
			;,     BCD0
			movlw		BCD0
			subwf		FSR,W
			btfsc		STATUS,Z
			return
			decf		FSR,F
			goto		next_byte
;---------------------- BCD to LCD ---------------------
;	      
DispBCD		movwf		FSR
NextNibble	swapf		INDF,F
		movf		INDF,W
		btfss		Flags,1 ;1 -    
		goto		chk_NZ
		andlw		0x0F
		btfsc		STATUS,Z
		return		; 
		bcf			Flags,1 ;      
chk_NZ
		btfss		Flags,3 ; 1-   NZ ,  - 0
		goto		NumLCD
		movf		NZ,F
		btfsc		STATUS,Z	;=0?
		goto		Disp0	;,  0
		decf		NZ,F	;,    
		call		NumLCD
		return
;---------------------- BCD ---------------------
;	      
BCD		movlw		0x20
		movwf		T1
		clrf		BCD0
		clrf		BCD1
		clrf		BCD2
		clrf		BCD3
		clrf		BCD4

BcdLoop	rlf		AARGB2, F
		rlf		AARGB1, F
		rlf		AARGB0, F
		rlf		AEXP, F

		rlf		BCD0, F
		rlf		BCD1, F
		rlf		BCD2, F
		rlf		BCD3, F
		rlf		BCD4, F
		decfsz		T1, F
		goto		Adjust
		return

Adjust	movlw		.5
		movwf		Count2

		movlw		BCD0
		movwf		FSR
		goto		ADloop+1

ADloop	incf		FSR, F
		call		Adjbcd
		decfsz		Count2, F
		goto		ADloop
		goto		BcdLoop

Adjbcd	movlw		0x03
		addwf		INDF, W
		movwf		T0		
		btfsc		T0, 3		
		movwf		INDF
		movlw		0x30
		addwf		INDF, W
		movwf		T0
		btfsc		T0, 7
		movwf		INDF
		return

;-------------------------------------------------------
;	 " "  (4 ) 
; Temp1 =   -    
; Temp2 =   -    

;CEQUA		movlw		CX		; C=A
Copy_From_A
		movwf		Temp1		; Xw=A
		movlw		AEXP
		movwf		Temp2
		goto		Copy

BEQUA		movlw		AEXP		; B=A
Copy_To_B	movwf		Temp2		; B=Xw
		movlw		BEXP
		goto		Copy_B

;AEQUF		movlw		FX		; A=F
Copy_To_A
		movwf		Temp2		; A=Xw
		movlw		AEXP

Copy_B	movwf		Temp1
Copy	movlw		4		;  
		movwf		Count1
Copy_Loop
		movf		Temp2, W
		movwf		FSR
		movf		INDF, W
		movwf		Temp3
		movf		Temp1, W
		movwf		FSR
		movf		Temp3, W
		movwf		INDF
		decf		Temp1, F ;    
		decf		Temp2, F ; 
		decfsz		Count1, F
		goto		Copy_Loop
		return

;-------------------------------------------------------
X_To_B	call		EEPROM_To_B	;   X
		call		ASwapB
		call		FLO2424
		call		FPM24
		return

ASwapB	movlw		T5
		call		Copy_From_A
		movlw		BEXP
		call		Copy_To_A
		movlw		T5
		call		Copy_To_B
		return		
;-------------------------------------------------------
;	    
ClrB	movlw		BEXP	;   
		goto		ClrA+1

ClrA	movlw		AEXP	;   
		movwf		FSR
		movlw		4	; 
		movwf		Count1

ClrLoop
		clrf		INDF	;  
		decf		FSR, F	;  
		decfsz		Count1, F
		goto		ClrLoop
		return
;-------------------------------------------------------
;	   EEPROM   B
EEPROM_To_B
		movwf		EE_ADR	;    EEPROM
		movlw		BEXP
		movwf		FSR
		movlw		4	; 
		movwf		Count1
EE_read_loop
	    call		ReadEEPROM
		banksel		BEXP
		movwf		INDF
		incf		EE_ADR, F
		decf		FSR, F
		decfsz		Count1, F
		goto		EE_read_loop
		return

;	 EEPROM
ReadEEPROM
		movf		EE_ADR,W ;
		banksel		EEADR 	;  2
		movwf		EEADR	;   EEPROM
		banksel		EECON1	; 3
		bcf			EECON1,EEPGD ; EEPROM 
		bsf			EECON1,RD    ; 
		banksel		EEDATA	; 2
		movf		EEDATA,W	; W = EEDATA
		return

;-------------------------------------------------------
;	  BARG  EEPROM
;   EEPROM   Const_ADR
Save_Const
		movf		Const_ADR,W
		movwf		EE_ADR
		movlw		BEXP
		movwf		FSR
		movlw		4	; 
		movwf		Count1
EE_write_loop
		movf		INDF,W
		movwf		EE_DATA
		call		WriteEEPROM
		banksel		BEXP
		incf		EE_ADR, F
		decf		FSR, F
		decfsz		Count1, F
		goto		EE_write_loop
		return

;	 EEPROM
WriteEEPROM
		banksel		EECON1	;3
		btfsc		EECON1,WR
		goto		$-1
		banksel		EE_ADR
		movf		EE_ADR,W
		banksel		EEADR	;2
		movwf		EEADR
		banksel		EE_DATA
		movf		EE_DATA,W
		banksel		EEDATA	;2
		movwf		EEDATA
		banksel		EECON1	;3
		bcf			EECON1,EEPGD
		bsf			EECON1,WREN
		movlw		0x55
		movwf		EECON2
		movlw		0xAA
		movwf		EECON2
		bsf			EECON1,WR
		nop
		bcf			EECON1,WREN
		return
;-------------------------------------------------------
;	  B
IncB
		bsf			Flags,5	;   
        incf		BARGB2, F
		btfsc		STATUS, Z
		incf		BARGB1, F
		goto		ShowX

;	  B
DecB
		bsf			Flags,5	;   
        movf		BARGB2, F
		btfsc		STATUS, Z
		decf		BARGB1, F
		decf		BARGB2, F

ShowX		
        movlw		BEXP
        call		Copy_To_A
		
		call		BCD
		call		SecLine
		movlw		BCD1
		call		DispBCD
		call		DispDot
		movlw		BCD1
		call		DispBCD
		movlw		BCD0
		call		DispBCD
		movlw		BCD0
		call		DispBCD
		
		call		Delay_05_sec
		return

;=======================================================
;     PIC16 24 BIT FLOATING POINT LIBRARY

#define P16_MAP1 0
#define P16_MAP2 1
        include "math16.inc" 
        include "fp24.a16"   
        
        


;*******************************************************************************
;**********       VGA       *****************************
;*******************************************************************************
VGA

;	Ceramic resonator 20MHz, Tcycle=0,2mkS
;	640*480 /60hz  31,4KHz/0.2mks=159   
;Horz=RB3	
		;***************640*480 /60hz **********

;   LCD
                call		ClrDSP		;  
  	   call	CursorHome
		movlw		LOW _640
		call		Read_String
           call SecLine
     		movlw           LOW _60	
		call		Read_String
	   call Delay_1_sec
		btfss		PORTA,Kn_Set
   	    goto $-1
		bcf	INTCON,7	; 	
;  
	 	movlw b'01001111'    
		movwf	Blanc      		;           
		movlw b'01001011' 			     
		movwf	Jaune      		;   Jaune        
		movlw b'01001110' 			     
                movwf	Cyan		;   Cyan         
		movlw b'01001010' 			     
		movwf	Vert			;   Vert         
		movlw b'01001101'			     
		movwf	Magenta		;   Magenta      
		movlw b'01001001' 			     
		movwf	Rouge			;   Rouge        
		movlw b'01001100' 			     
		movwf	Bleu			;   Bleu   	     	

;===================================================
		movlw b'00000000'                   
START:	        movwf PORTB       	  ;vsync + hsync,   1
		call	Pause15		
		bsf	Horz                      ;End of sync      17
     	        call Pause136		        ;17,153
        	movlw d'28'	      	        ;154
		movwf	Count1     	  	        ;155
  		movlw D'239'                    ;156
		movwf	Count2 	              ;157
		movwf	Count3		        ;158
		nop         	              ;159      1ctroka
;===================================================
      	        bcf	Horz                ; Horz sync ,     1
		call	Pause15			 
		bsf	Horz	                    ; end of sync     17
	        call Pause136		        ;17,153
		nop			              ;154
		nop	      		        ;155
      	        nop		              ;156		    
		movlw D'10'                     ;157
		movwf	Count4 	              ;158	         				     
		movlw b'01000000'	              ;159	  2ctroka
;===================================================	
		movwf PORTB  		        ;end of vsync + hsync, 1
	        call	Pause15	
		bsf	Horz                      ; end of hsync         17
	     	call Pause136		        ;17,153     
      	        nop		              ;154		
		nop	      		        ;155
      	        nop		              ;156		
		nop	      		           	
                nop       	              ;158					     	     
	        nop         		        ;159	 3ctroka
;===================================================
Loop1		bcf	Horz                      ; Horz sync ,     1
		call	Pause15			 
		bsf	Horz	                    ; end of sync     17
	        call Pause136		        ;17,153
	        nop			              ;154
	        nop			              ;155
		nop			              ;156
		decfsz Count1,f                 ;157,158 20cikle
                goto Loop1        	        ;158,159
	        nop 			 	  ;159    31ctroka
;===================================================
Loop2      	bcf	Horz                      ; Horz sync ,     1
	        call	Pause15
		bsf	Horz                      ;End of sync      17
      	        nop		              ;18		
		nop	      		        ;19
      	        nop		              ;20
		nop				        ;21
	        movf  Blanc,w	              ;	    22
		movwf PORTB		              ;                 23
		call	Pause17
		movf  Jaune,w	              ; 		    41
		movwf PORTB		              ; Jaune	    42
		call	Pause17
		movf Cyan,w		              ;		    60
		movwf PORTB		              ; Cyan	    61
		call	Pause17
		movf Vert,w		              ;		    79
		movwf PORTB                     ; Vert            80
		call	Pause17
		movf Magenta,w	              ;		    98
		movwf PORTB      	              ; Magenta         99
		call	Pause17
		movf Rouge,w	              ;		    117
		movwf PORTB		              ; Rouge           118
		call	Pause17
		movf Bleu,W		              ;		    136
		movwf PORTB		              ; Bleu            137
		call	Pause17                   ;154
	        movlw b'01001000'		  ;155
		movwf PORTB		              ;156
		           
		decfsz Count2,f                 ;   239cikl       157
                goto Loop2        		  ;158,159
		nop	      			  ;159 
;===================================================
Loop3	   	bcf	Horz                  ; Horz sync ,     1
	        call	Pause15
		bsf	Horz                  ;End of sync      17
      	        nop		          ;18		
		nop	      		    ;19
      	        nop		          ;20
		nop				    ;21
	        movf  Blanc,w	          ; 		   22
		movwf PORTB		          ; Blanc          23
		call	Pause17
		movf  Jaune,w	          ; 		   41
		movwf PORTB		          ; Jaune  	   42
		call	Pause17
		movf Cyan,w		          ;60
		movwf PORTB		          ; Cyan           61
		call	Pause17
		movf Vert,w		          ;79
		movwf PORTB                 ; Vert           80
		call	Pause17
		movf Magenta,w	          ;98
		movwf PORTB      	          ; Magenta        99
		call	Pause17
		movf Rouge,w	          ;117
		movwf PORTB		          ; Rouge          118
		call	Pause17
		movf Bleu,W		          ;136
		movwf PORTB		          ; Bleu           137
		call	Pause17               ;154
	        movlw b'01001000' 	    ;155
		movwf PORTB			    ;156
	        
		decfsz Count3,f             ;   239cikl      157
                goto Loop3              ;158,159
		nop	      	          ;159   
;===================================================
Loop4           bcf	Horz            ; Horz sync ,    1
		call	Pause15			 
		bsf	Horz	                ; end of sync    17
		call Pause136		    ;17,153
		nop			          ;154
		nop			          ;155
		nop			          ;156
		decfsz Count4,f   	    ;157     10cikl
                goto Loop4              ;158,159
		nop	      	          ;159
;************************************************
      	        bcf	Horz                  ; Horz sync ,     1
		call	Pause15			 
		bsf	Horz	                      ; end of sync     17

		btfsc		PORTA,Kn_Set          ;18
		goto		$+2		          ;19,20
          	goto	Sw 
		call Pause136		          ;156
	
		movlw b'00000000'                 ;157  
		goto START                        ;158,159
;************************************************
Sw          	;.
          
	        bsf   PCLATH,3
         	goto	LMETR
;************************************************
;************************************
Pause15     movlw       .3
            movwf       Temp1
M1          decfsz      Temp1, F
            goto        M1
            nop
         return
Pause17     movlw       .3
            movwf       Temp1
M3          decfsz      Temp1, F
            goto        M3
            nop
            nop
            nop
	 return
;delay = 132 machine cycles
Pause136      movlw       .43
            movwf       Temp1
M2          decfsz      Temp1, F
            goto        M2
            nop
            nop        
	 return

;************************************************************************
;***********          LMETR      **********************************
;************************************************************************
  org 	0x800 ;  1

LMETR
	 call CLR_LCD; 
       call Line1
       movlw " "
       call  SendASCII
       movlw "L"
       call  SendASCII
       call Text_Metr
       call Pause05sek 
		btfss		PORTA,Kn_Set  
   	    goto $-1
		 clrf Flag_F		
;************************************************************************          
;            Initialize the ports and timer1                           ;
;----------------------------------------------------------------------;
            bsf    STATUS,RP0
            movlw B'11110111'          ;  PortA all inputs
            movwf  TRISA
            movlw  0x00                ;  all outputs on port B
            movwf  TRISB
            movlw B'11110011'          ;RC2,RC3 outputs other inputs
            movwf  TRISC
            bcf    STATUS,RP0
            clrf   PORTA
            clrf   PORTB
            clrf   PORTC
            movlw  B'00000110'
            movwf  T1CON
            bcf    T1CON,0      ;0  TMR1ON:  TMR1    1=.
; T1CON  10
; 6-7  
; 5-4 T1CKPS1:T1CKPS0:    TMR1
;	11=1:8
;       10=1:4
;	01=1:2
;	00=1:1
;3 T1OSEN:   TMR1 1=. 0=.
;2 T1SYNC:C    1- 
;1 TMR1CS:    
;        1=     RC0
;0  TMR1ON:  TMR1    1=.
;-------------------------------------------------------------------------;
            bcf    PORTB,6; 
            bsf    PORTB,7;  LC 
;-------------------------------------------------------------------------;
Restart
;----------  c_metr----------------------------------------------
		btfsc		PORTA,Kn_Set  
   	    goto $+2
           	call _metr 

;-------------------------------------------------------------------------;
;   LC .   LC                                           ;
;    \REGA0\ REGA1\ F=F/100
;-------------------------------------------------------------------------;
    call LC_F

;****   1300   ********************************
	movlw    0x01	 ; 
        subwf    REGA1,0 ;
 	btfsc STATUS,C
       goto   A_F        ;

	movlw    0x83	 ; d'01'
        subwf    REGA0,0 ;
 	btfsc STATUS,C
       goto   A_F        ;   1500  
	 call CLR_LCD	; 
        call  Line1	;   1- 	
	    call  Text_Lx

            goto    Restart
A_F
;--------    --------------------------;

	movf    REGA1,0	;
	movwf   REGB1	;
	movf    REGA0,0	;
	movwf   REGB0	;

    call  multiply	;.    REGA 
;---------   1000()------------------------------------;
	clrf	REGB3
	clrf	REGB2
  	movlw   0x03  	;   
	movwf   REGB1	
  	movlw   0xE8  	;   
	movwf   REGB0	;
    call  divide	;.    REGA

;  F^2/1000
	movf    REGA1,0	;
	movwf   T1	;
	movf    REGA0,0	;
	movwf   T0	;

;--------------------------------------------------------------

	        btfsc  PORTA,Kn_Plus
	      goto   K_C
	    call   Pause05sek 
		btfsc  PORTA,Kn_Plus
	      goto   K_C
	    call   Cal_L
K_C          
;------------------------------------------------------------------------- 
;************   F mkH = 25330/C/F^2************************
;------- 253 300 000-------------------------------------

	movlw 0x0F	;   
	movwf REGA3	;

	movlw 0x19	;  
	movwf REGA2	;

	movlw 0x0D	;  
	movwf REGA1	;

	movlw 0x20	;  
	movwf REGA0	;

;--------------   C xxx pF--------------------------------
;===============================================================================================
;  EEPROM     24h      REGB1.  pF
;-----------------------------------------------------------------------------------------------
	clrf	REGB3
	clrf	REGB2
	   movlw      0x24
	call LO_EEPR
	   movwf      REGB1

;  EEPROM     25h      REGB0.

            movlw      0x25           ;     EEPROM 25h
	call LO_EEPR
            movwf      REGB0          ;  24h   W   EEAdr.
;-----------------------------------------------------------------
	call  divide	;.    REGA 

;   1000.   
	clrf	REGB3
	clrf	REGB2

	movlw 0x03	;
	movwf REGB1	;
	movlw 0xE8	;  1000
	movwf REGB0	;

    call  multiply	;.    REGA 

;-------  F^2 ----------------------------
	clrf	REGB3
	clrf	REGB2
        movf  T1,0   ;  
     	movwf REGB1	;

 	movf  T0,0  	;  
	movwf REGB0	;

    call  divide	;.    REGA 

;    Cal_L,  0
;  EEPROM  2-  
        movf  REGA1,0   ;   
     	movwf T3	;
 	movf  REGA0,0  	;  
	movwf T2	;
;--------------------------------------------------------------------------------------
            btfss  T5,0 ;   ר  \C\L\
	      goto   $+7
;   100.   
	clrf	REGB3
	clrf	REGB2
	clrf	REGB1
	movlw 0x64	;  100
	movwf REGB0	;
    call  multiply	;.    REGA 
;---------------------------------------------------------------------------------------
;  10000  , 0
      clrf	REGB3
	clrf	REGB2
;  EEPROM     28h      REGB1.
	   movlw      0x28
	call LO_EEPR
	   movwf      REGB1

;  EEPROM     29h      REGB0.

            movlw      0x29           ;     EEPROM 25h
	call LO_EEPR
            movwf      REGB0          ;  29h   W   REGB0.
;----------- --------------------------------------------
       call Line1    ; Line
	 call CLR_Line
            call  Line1 	;   1- 
 	     	movlw "L"
       	call  SendASCII 
       	movlw "x"
       	call  SendASCII 
       	movlw " "
       	call  SendASCII 
;--------------------------------------------------------------------
    call  subtract	;.    REGA  0
;******************   ******************************** 

;-----------   ----------------------------------------
 ;	btfsc STATUS,DC
      goto   $+3
       	movlw "-"
       	call  SendASCII
;--------------------------------------------------------------------       
 
       call bin2dec     ;  REGA ---> DIGIT


;  ------------------------------------------ 
 
	movlw    0x01	   ; 
        subwf    DIGIT1,0  ;
 	btfsc STATUS,C
       goto   Lx_H         ;   Lx- xx.xx H

	movlw    0x01	   ; 
        subwf    DIGIT2,0  ;
 	btfsc STATUS,C
       goto   Lx_H         ;   Lx- x.xx H

	movlw    0x01	   ; 
        subwf    DIGIT3,0 ;
 	btfsc STATUS,C
       goto  Lx_mH        ;   Lx- xxx.xx mH

	movlw    0x01	  ; 
        subwf    DIGIT4,0 ;
 	btfsc STATUS,C
       goto  Lx_mH1         ;   Lx- xx.xx mH

	movlw    0x01	  ; 
        subwf    DIGIT5,0 ;
 	btfsc STATUS,C
       goto   Lx_mH2      ;    Lx- x.xx mH

	movlw    0x01	  ; 
        subwf    DIGIT6,0 ;
 	btfsc STATUS,C
       goto   Lx_ukH      ;   Lx- xxx.xx ukH

	movlw    0x01	  ; 
        subwf    DIGIT7,0 ;
 	btfsc STATUS,C
       goto   Lx_ukH1     ;   Lx- xx.xx ukH 

       goto   Lx_ukH2     ;   Lx- x.xx ukH 
;-----------------------------------------------------------------------;
;           Lx- xxx.xx ukH                                ;
;-----------------------------------------------------------------------; 
Lx_ukH

	movf  DIGIT6,0
       addlw "0"
       call  SendASCII   
Lx_ukH1       movf  DIGIT7,0
       addlw "0"
       call  SendASCII 
Lx_ukH2       movf  DIGIT8,0
       addlw "0"
       call  SendASCII
        movlw ","
       call  SendASCII 
       movf  DIGIT9,0
       addlw "0"
       call  SendASCII 
      movf  DIGIT10,0
       addlw "0"
       call  SendASCII 
        movlw " "
       call  SendASCII

       movlw "u"
       call  SendASCII
       movlw "k"
       call  SendASCII
       movlw "H"
       call  SendASCII
       goto    Restart
;-----------------------------------------------------------------------;
;             Lx- xxxx.x mH                               ;
;-----------------------------------------------------------------------; 
Lx_mH
     
       movf  DIGIT3,0
       addlw "0"
       call  SendASCII 
Lx_mH1       movf  DIGIT4,0
       addlw "0"
       call  SendASCII
Lx_mH2       movf  DIGIT5,0
       addlw "0"
       call  SendASCII
       movlw "."
       call  SendASCII  
       movf  DIGIT6,0
       addlw "0"
       call  SendASCII
       movf  DIGIT7,0
       addlw "0"
       call  SendASCII
       movlw " "
       call  SendASCII

       movlw "m"
       call  SendASCII
       movlw "H"
       call  SendASCII
        goto    Restart
;-----------------------------------------------------------------------;
;-----------------------------------------------------------------------;
;               Lx- xx.xx H                               ;
;-----------------------------------------------------------------------; 
Lx_H
       
        movf  DIGIT1,0
       addlw "0"
       call  SendASCII
       movf  DIGIT2,0
       addlw "0"
       call  SendASCII
        movlw ","
       call  SendASCII 
       movf  DIGIT3,0
       addlw "0"
       call  SendASCII 
       movf  DIGIT4,0
       addlw "0"
       call  SendASCII
        movf  DIGIT5,0
          movlw " "
       call  SendASCII

       movlw "H"
       call  SendASCII
       movlw "e"
       call  SendASCII 
       movlw "n"
       call  SendASCII
        movlw " "
       call  SendASCII	  
       goto    Restart

;************************************************************************
;***********  *************************************
;************************************************************************
_metr
       call Line1    ; 
	 call CLR_Line
       call Line2 
	 call CLR_Line

       call Line1
       movlw " "
       call  SendASCII
       movlw "C"
       call  SendASCII
       call Text_Metr 
       call Pause1sek
		btfss		PORTA,Kn_Set
   	    goto $-1
	 clrf Flag_F
;-------------------------------------------------------------------------;
            bsf    PORTB,6; 
            bsf    PORTB,7;  LC 
;-------------------------------------------------------------------------;
_Restart
;----------  F_metr----------------------------------------------
		btfsc		PORTA,Kn_Set  
   	    goto $+2
           	call F_metr 
;-------------------------------------------------------------------------;
;   LC .   LC                                           ;
;    \REGA0\ REGA1\ F=F/100   10
;-------------------------------------------------------------------------;
    call LC_F

;****   5100/510   ********************************
	movlw    0x02	 ; 
        subwf    REGA1,0 ;
 	btfsc STATUS,C
       goto   A_C       ;

	movlw    0xFE	 ; 
        subwf    REGA0,0 ;
 	btfsc STATUS,C
       goto   A_C        ;   5100  

       call Line1    ; 
	 call CLR_Line
       call Line2 
	 call CLR_Line

        call  Line1	;   1- 	
	    call  Text_ERROR

            goto    _Restart
A_C
;************   C pF = 25330/L=100/F^2*******************;
;***********************************************************************;
;--------    --------------------------;

	movf    REGA1,0	;
	movwf   REGB1	;
	movf    REGA0,0	;
	movwf   REGB0	;

    call  multiply	;.    REGA 
;---------   1000()------------------------------------;
	clrf	REGB3
	clrf	REGB2
  	movlw   0x03  	;   
	movwf   REGB1	
  	movlw   0xE8  	;   
	movwf   REGB0	;
    call  divide	;.    REGA

	movf    REGA1,0	;
	movwf   REGB1	;
	movf    REGA0,0	;
	movwf   REGB0	;

;------- 253 300 000----------------------

	movlw 0x0F	;   
	movwf REGA3	;

	movlw 0x19	;  
	movwf REGA2	;

	movlw 0x0D	;  
	movwf REGA1	;

	movlw 0x20	;  
	movwf REGA0	;
    call  divide	;.C pF = 25330/F^2 

;----------------------------------------------------------------------

	        btfsc  PORTA,Kn_Plus
	      goto   EN_CAL
	    call   Pause05sek
		btfsc  PORTA,Kn_Plus
	      goto   EN_CAL
       	    call  Line1
	    call   Text_Cal
       	    call  Line2
        call CLR_Line
;     EEPROM 2Ch.    
         movf  REGA1,0
            movwf   TEMP 
 	 movlw      0x2C
	 call SAV_EEPR;     EEPROM W. TEMP. W

;     EEPROM 2Dh.     
         movf  REGA0,0
            movwf  TEMP
 	 movlw      0x2D
	 call SAV_EEPR;     EEPROM W. TEMP. W
            call Pause05sek

	 call CLR_LCD ; 

EN_CAL
;--------------------------------------------------------------------------------------
            btfss  T5,0 ;   ר  \C\L\
	      goto   $+7
;   100.   
	clrf	REGB3
	clrf	REGB2
	clrf	REGB1
	movlw 0x64	;  100
	movwf REGB0	;
    call  multiply	;.    REGA 
;---------------------------------------------------------------------------------------
; ~ 650*10 Cx+C , 
; EEPROM     44h      REGB0.
	   movlw      0x2C
	call LO_EEPR
	   movwf      REGB1

;  EEPROM     45h      REGB0.

            movlw      0x2D           ;     EEPROM 45h
	call LO_EEPR
            movwf      REGB0          ;  45h   W   REGB0.

	clrf	REGB3
	clrf	REGB2
 ;----------- --------------------------------------------
       call Line1    ; Line
	 call CLR_Line
            call  Line1 	;   1- 
 	     	movlw "C"
       	call  SendASCII 
       	movlw "x"
       	call  SendASCII 
       	movlw " "
       	call  SendASCII 
;--------------------------------------------------------------------
    call  subtract	;.    REGA, 
;******************   ******************************** 

;-----------   -----------------------
 ;	btfsc STATUS,DC
      goto   $+3
       	movlw "-"
       	call  SendASCII
;--------------------------------------------------------------------     
       call bin2dec     ;  REGA ---> DIGIT

;  ------------------------------------------ 
	movlw    0x01	   ; 
        subwf    DIGIT3,0  ;
 	btfsc STATUS,C
       goto  Cx_uF          ;   Lx- x.xx ukF

	movlw    0x01	   ; 
        subwf    DIGIT4,0  ;
 	btfsc STATUS,C
       goto  Cx_nF        ;   Lx- xx.xx nF

	movlw    0x01	   ; 
        subwf    DIGIT5,0  ;
 	btfsc STATUS,C
       goto   Cx_nF1       ;    Lx- x.xx nF

	movlw    0x01	   ; 
        subwf    DIGIT6,0  ;
 	btfsc STATUS,C
       goto   Cx_pF       ;   Lx- xxx.xx pF

	movlw    0x01	   ; 
        subwf    DIGIT7,0  ;
 	btfsc STATUS,C
       goto   Cx_pF1      ;   Lx- xx.xx pF 

       goto   Cx_pF2      ;   Lx- x.xx pF 
;-----------------------------------------------------------------------;
;           Cx- xxxx.xx pF                                ;
;-----------------------------------------------------------------------; 
Cx_pF
	movf  DIGIT6,0
       addlw "0"
       call  SendASCII   
Cx_pF1        movf  DIGIT7,0
       addlw "0"
       call  SendASCII 
Cx_pF2       movf  DIGIT8,0
       addlw "0"
       call  SendASCII

      movf  DIGIT9,0
       addlw "0"
       call  SendASCII 

        movlw ","
       call  SendASCII 

      movf  DIGIT10,0
       addlw "0"
       call  SendASCII

         movlw " "
       call  SendASCII 
       movlw "p"
       call  SendASCII
       movlw "F"
       call  SendASCII
	  
       goto    _Restart
;-----------------------------------------------------------------------;
;             Cx- xxx.x nF                               ;
;-----------------------------------------------------------------------; 

Cx_nF       movf  DIGIT4,0
       addlw "0"
       call  SendASCII
Cx_nF1       movf  DIGIT5,0
       addlw "0"
       call  SendASCII
       movf  DIGIT6,0
       addlw "0"
       call  SendASCII
       movlw "."
       call  SendASCII 
       movf  DIGIT7,0
       addlw "0"
       call  SendASCII
       movlw " "
       call  SendASCII

       movlw "n"
       call  SendASCII
       movlw "F"
       call  SendASCII

        goto    _Restart
;----------------------------------------------------------------------;
;-----------------------------------------------------------------------;
;               Cx- x.xx ukF                               ;
;-----------------------------------------------------------------------; 
Cx_uF
       
       movf  DIGIT3,0
       addlw "0"
       call  SendASCII
        movlw ","
       call  SendASCII 
       movf  DIGIT4,0
       addlw "0"
       call  SendASCII 
       movf  DIGIT5,0
       addlw "0"
       call  SendASCII
        movf  DIGIT6,0
          movlw " "
       call  SendASCII

       movlw "u"
       call  SendASCII
       movlw "k"
       call  SendASCII 
       movlw "f"
       call  SendASCII	  
       goto    _Restart

;*******************************************************************
;********** ***************************************
;*******************************************************************
F_metr
;----------  F Metr-------------------------------------- 
       call Line1    ; 
	 call CLR_Line
       call Line2 
	 call CLR_Line

       call Line1
       movlw " "
       call  SendASCII
       movlw "F"
       call  SendASCII
	 call Text_Metr
       call Pause1sek
 		btfss		PORTA,Kn_Set
	      goto $-1

;-------------------------------------------------------------------------;
            bcf    PORTB,6; 
            bcf    PORTB,7;  LC 
;-------------------------------------------------------------------------;
F_start
;----------  ESR metr---------------------------------------
          btfsc	PORTA,Kn_Set  
  	    goto LF1
	 call CLR_LCD

         call Line1 
       movlw " "
       call  SendASCII
       movlw "E"
       call  SendASCII
       movlw "S"
       call  SendASCII
       movlw "R"
       call  SendASCII
       movlw " "
       call  SendASCII
		call Text_Metr
 		btfss		PORTA,Kn_Set
	      goto $-1
	        bcf   PCLATH,3
            goto	init

LF1
		btfss		PORTA,Kn_Minus
		call	CH
;----------------------------------------------------------------------------------
;   RC0  T=1sek-    \REGA0 \REGA1 \REGA02 \REGA3\ 
 
       call  Count_FHz ;  
;----------------------------------------------------------------------------------       
	 call CLR_LCD
       call bin2dec     ;  REGA ---> DIGIT
 
;  ------------------------------------------------------------------ 

       call  Line1	;   1- 	
       movlw "F"
       call  SendASCII
       movlw "x"
       call  SendASCII
       movlw " "
       call  SendASCII
       call  FreqHz     ;  
;----------------------------------------------------------------------------- 

 	 goto  F_start

;*****************************************************************************
;****************** F Metr****************************************
;-----------------------------------------------------------------------------;
;   RC0   Hz-    \REGA0\ REGA1\\REGA2\ REGA3\   ;
;-----------------------------------------------------------------------------;
Count_FHz 
                movlw   B'000000110'; 5-4 :    TMR1
       	    movwf   T1CON	      ;	 00=1:1       
            movlw       .229
            movwf       Temp4
            movlw       .4
            movwf       Temp
       clrf    REGA0	 
       clrf    REGA1
       clrf    REGA2	
       clrf    REGA3
       clrf    TMR1H    ;TMR1H-  16-  1
       clrf    TMR1L	;TMR1L-  16-  1
       bcf     PIR1,0	;     TMR1
       bsf     T1CON,0  ;0  TMR1ON:  TMR1    1=.

;====    1======================================================

del         movlw       .126
            movwf       Temp1
            movlw       .7
            movwf       Temp2
wrF         decfsz      Temp1, F
            goto        wrF
            decfsz      Temp2, F
            goto        wrF
;===========================================================================================
;    TMR1   REGA2
;    REGA2   REGA3
;===========================================================================================
            btfss      PIR1,0      ; TMR1   ?
            goto       Do          ; ,   -->     Do.
            incf       REGA2,F     ; ,  -->    REGA2
                                   ;       .
            btfsc      STATUS,Z
            incf       REGA3,F
  
            bcf        PIR1,0      ;    TMR1.
            nop 
            goto       CK          ;    CK.

Do          nop                    ;  NOP.
            nop                    ;  NOP.
            nop                    ;  NOP.
            nop                    ;  NOP.
            nop                    ;  NOP. 8CIKL
            nop                    ;  NOP. 9CIKL
  
CK          decfsz      Temp4,F 
            goto        del
            decfsz      Temp,F               
            goto        del
;====     1 .=========================================
            movlw       .11
            movwf       Temp1
            decfsz      Temp1, F
	      goto   $-1
            nop
            nop 
            nop

;====    1-================================================ 

       bcf     T1CON,0  ;0  TMR1ON:  TMR1    1=.

            btfss      PIR1,0      ; TMR1   ?
            goto       $+4         ; ,   -->   .
            incf       REGA2,F     ; ,  -->    REGA2
                                   ;       .
            btfsc      STATUS,Z
            incf       REGA3,F

       movf    TMR1H,0  ;TMR1H-  16-  1,0
       movwf   REGA1
       movf    TMR1L,0	;TMR1L-  16-  1,0
       movwf   REGA0	; c TMR1    REGA 
       return
;------------------------------------------------------------------------------------;
;     RC0 -    \REGA0\ REGA1\\REGA2\ REGA3\    ;
;------------------------------------------------------------------------------------;
;------------------------------------------------------------------------------------;
;      LCD 2*16                                                      ;
;------------------------------------------------------------------------------------;
FreqHz
	movlw    0x01	   ; 
        subwf    DIGIT3,0  ;
 	btfss STATUS,C
       goto   $+5          ;   

	movf  DIGIT3,0
       addlw "0"
       call  SendASCII 
       goto   $+5 

	movlw    0x01	   ; 
        subwf    DIGIT4,0  ;
 	btfss STATUS,C
       goto   $+7          ;   

	movf  DIGIT4,0
       addlw "0"
       call  SendASCII 

       movlw " "
       call  SendASCII
       goto   $+5

	movlw    0x01	   ; 
        subwf    DIGIT5,0  ;
 	btfss STATUS,C
       goto   $+4          ;   

	movf  DIGIT5,0
       addlw "0"
       call  SendASCII 

	movf  DIGIT6,0
       addlw "0"
       call  SendASCII   
       movf  DIGIT7,0
       addlw "0"
       call  SendASCII 

       movlw " "
       call  SendASCII

       movf  DIGIT8,0
       addlw "0"
       call  SendASCII
       movf  DIGIT9,0
       addlw "0"
       call  SendASCII 
      movf  DIGIT10,0
       addlw "0"
       call  SendASCII 

       movlw " "
       call  SendASCII
       movlw "H"
       call  SendASCII
       movlw "z"
       call  SendASCII	  
      return  
  
;**********************************************************************************;
;****************** LC Metr********************************************;
;**********************************************************************************;
;----------------------------------------------------------------------------------;
;   RC0 F=F/10 Hz-    \REGA0\ REGA1\\REGA2\ REGA3\   ;
;----------------------------------------------------------------------------------;
Count_LC        movlw   B'000100110'; 5-4 :    TMR1
       	    movwf   T1CON	      ;	 10=1:4      
            movlw       .200
            movwf       Temp4
            movlw       .2
            movwf       Temp
       clrf    REGA0	
       clrf    REGA1
       clrf    REGA2	 
       clrf    REGA3
       clrf    TMR1H    ;TMR1H-  16-  1
       clrf    TMR1L	;TMR1L-  16-  1
       bcf     PIR1,0	;     TMR1
       bsf     T1CON,0  ;0  TMR1ON:  TMR1    1=.

;====    0.4============================================;

delC        movlw       .173
            movwf       Temp1
            movlw       .6
            movwf       Temp2
wrC         decfsz      Temp1, F
            goto        wrC
            decfsz      Temp2, F
            goto        wrC
;===================================================================================;
;    TMR1   REGA2
;    REGA2   REGA3
;===================================================================================;
            btfss      PIR1,0      ; TMR1   ?
            goto       DoC         ; ,   -->     Do.
            incf       REGA2,F     ; ,  -->    REGA2
                                   ;       .
            btfsc      STATUS,Z
            incf       REGA3,F
  
            bcf        PIR1,0      ;    TMR1.
            goto       CKC         ;    CKC.

DoC         nop                    ;  NOP.
            nop                    ;  NOP.
            nop                    ;  NOP.
            nop                    ;  NOP.
            nop                    ;  NOP. 8CIKL
  
CKC         decfsz      Temp4,F 
            goto        delC
            decfsz      Temp,F               
            goto        delC
;  .......     0.4 ..............................

            movlw       .145
            movwf       Temp1
            decfsz      Temp1, F
	      goto   $-1
            nop

;====    0.4-========================================== 

       bcf     T1CON,0  ;0  TMR1ON:  TMR1    1=.

            btfss      PIR1,0      ; TMR1   ?
            goto       $+4         ; ,   -->     Do.
            incf       REGA2,F     ; ,  -->    REGA2
                                   ;       .
            btfsc      STATUS,Z
            incf       REGA3,F

       movf    TMR1H,0  ;TMR1H-  16-  1,0
       movwf   REGA1
       movf    TMR1L,0	;TMR1L-  16-  1,0
       movwf   REGA0	; c TMR1    REGA 
       return
;------------------------------------------------------------------------------------;
;     RC0 -    \REGA0\ REGA1\\REGA2\ REGA3\    ;
;------------------------------------------------------------------------------------;
;------------------------------------------------------------------------------------;
;   LC .   LC                                           ;
;    \REGA0\ REGA1\ F=F/100
;------------------------------------------------------------------------------------;
LC_F
           call  Count_LC    ;  LC 
;    LC 
	clrf	  REGB3
	movf    REGA2,0	;
	movwf   REGB2	;
	movf    REGA1,0	;
	movwf   REGB1	;
	movf    REGA0,0	;
	movwf   REGB0	;

;----------/.  LC  F/10 ------------
		btfss    Flag_F,0
   	    goto $+8
		btfsc		PORTA,Kn_Minus
   	    goto $+6
	 clrf Flag_F
	 call CLR_LCD
   		call Pause05sek
		btfss		PORTA,Kn_Minus
   	    goto $-1

		btfsc    Flag_F,0
   	    goto FC
		btfsc		PORTA,Kn_Minus  
   	    goto E_FC
   		call Pause05sek

	movlw    0x01
	movwf    Flag_F
;------------------------------------------------------------------------
FC       call bin2dec     ;  REGA ---> DIGIT
       call  Line2	;   2- 	
       call  FreqHz     ;  
       movlw " "
       call  SendASCII
       movlw "*"
       call  SendASCII
       movlw "1"
       call  SendASCII
       movlw "0"
       call  SendASCII
		btfss		PORTA,Kn_Minus
   	    goto $-1
;------------------------------------------------------------------------
E_FC
;  LC   REGA
	clrf	  REGA3
	movf    REGB2,0	;
	movwf   REGA2	;
	movf    REGB1,0	;
	movwf   REGA1	;
	movf    REGB0,0	;
	movwf   REGA0	;
;-----------------------------------------------------------------------
;****   7 936     10 ***********************
	movlw    0x01	 ; 
        subwf    REGA2,0 ;
 	btfsc STATUS,C
       goto   D_F        ;

	movlw    0x1F	 ; 
        subwf    REGA1,0 ;
 	btfsc STATUS,C
       goto   D_F        ;

  	movlw   0x01  	 ;   ר  \C\L\
	movwf   T5
               goto   D_F1
D_F
	clrf	T5
;---------     10-------------------------------;
	clrf	REGB3
	clrf	REGB2
	clrf	REGB1
  	movlw   0x0A  	;   10
	movwf   REGB0	;
    call  divide	;.    REGA 
D_F1
       return
 
;---------------------------------------------------------------------------------- 
;***************   Lx ************************************************
Cal_L
	 call Line1 
	call Text_Cal

;-------  ----------------------
;------- 253 300 000---------------------
	movlw 0x0F	;   
	movwf REGA3	;
	movlw 0x19	;  
	movwf REGA2	;
	movlw 0x0D	;  
	movwf REGA1	;
	movlw 0x20	;  
	movwf REGA0	;

;-------  F^2 ----------------------------
	clrf	REGB3
	clrf	REGB2
        movf  T1,0  ;  
     	movwf REGB1	;
 	movf  T0,0  ;  
	movwf REGB0	;

	call  divide	;.    REGA 

	clrf	REGB3
	clrf	REGB2
	clrf	REGB1
	movlw 0x0A	;  
	movwf REGB0
	call  divide
;-------------------   EEPROM --------------------------------------------------
;     EEPROM 24h.    
        movf  REGA1,0
            movwf   TEMP 
 	 movlw      0x24
	call SAV_EEPR
;     EEPROM 25h.     
         movf  REGA0,0
            movwf  TEMP
 	 movlw      0x25
	call SAV_EEPR

       call bin2dec     ;  REGA ---> DIGIT

        call Line2 
        movlw "C"
        call  SendASCII
        movlw "x"
        call  SendASCII
        movlw " "
        call  SendASCII

        movf  DIGIT8,0
        addlw "0"
        call  SendASCII
        movf  DIGIT9,0
        addlw "0"
        call  SendASCII 
        movf  DIGIT10,0
        addlw "0"
        call  SendASCII 

        movlw "p"
        call  SendASCII
        movlw "F"
        call  SendASCII

; 10000  +, 0
;  EEPROM  2-  
;     EEPROM 29h. 
        movf  T2,0
            movwf   TEMP 
 	 movlw      0x29
	call SAV_EEPR
;     EEPROM 28h. 
         movf  T3,0
            movwf  TEMP
 	 movlw      0x28
	call SAV_EEPR
            call Pause05sek 
       call CLR_LCD    ; 
          return
;***************  ***************************
;===============================================================================================
;      movlw 0x--h      W.  pF
;-----------------------------------------------------------------------------------------------
;      XXh      W.

LO_EEPR
            bsf        STATUS,RP1
            bcf        STATUS,RP0     ;    2.
            movwf      EEADR          ;  24h   W   EEAdr.
            bsf        STATUS,RP0       ;    3.
            bcf        EECON1,EEPGD     ; EEPROM .
	      bsf	     EECON1,RD        ; 
            bcf        STATUS,RP0       ;     2.
            movf       EEDATA,W    ;     EEPROM   25h   W.
	    bcf    STATUS,RP1
 	    bcf    STATUS,RP0	   ;   0
 		return
;-------------------   EEPROM --------------------------------------------------
;     EEPROM W. TEMP.
SAV_EEPR	    bsf        STATUS,RP1
            bsf        STATUS,RP0      ;    3.
	    btfsc        EECON1,WR
	    goto   $-1
	    bcf        STATUS,RP0      ;     2.
          movwf      EEADR           ;  00h   W   EEAdr.
	bcf    STATUS,RP1
 	bcf    STATUS,RP0	   ;   0
            movf       TEMP,W 
	      bsf        STATUS,RP1      ;     2.
            movwf      EEDATA          ;     W   EEDATA
            bsf        STATUS,RP0      ;    3.
            bcf        EECON1,EEPGD    ;  EEPROM .
	      bsf        EECON1,WREN     ;  
            bcf        INTCON,GIE      ;   .            
            movlw      055h            ; 
            movwf      EECON2          ; 
            movlw      0AAh            ;  .
            movwf      EECON2          ; ----"----
            bsf        EECON1,WR       ;  
           ;bcf        INTCON,GIE      ;  . 
            bcf        EECON1,WREN     ;  
	bcf    STATUS,RP1
 	bcf    STATUS,RP0	   ;   0
 		return
;----------------------------------------------------------------------;
;  ASCII                                                   ;
;----------------------------------------------------------------------;
SendASCII
 
	movwf		Temp			; Temp=W
	swapf		Temp, W		; W=swap(W)
		andlw		0x0F		
		iorlw		b'00010000'	; RS=1,  w=(swap(W) & 0x0F) | b'00010000'
		iorwf		PORTB,f
		iorlw		b'11100000' ; 
		andwf		PORTB,f		

		bsf		_E
		nop
		nop
		nop
		bcf		_E
		movf		Temp, W
		andlw		0x0F
		iorlw		b'00010000'	; RS=1
		iorwf		PORTB,f
		iorlw		b'11100000' ; 
		andwf		PORTB,f		

	bsf		_E
		nop
		nop
		nop
		bcf		_E
		movlw		b'00011111'
		iorwf		PORTB,f		
		call		Delay_200_us1
		return
;----------------------------------------------------------------------;
;              	 	                                   ;
;----------------------------------------------------------------------;

SendINS                         ;  Send the Instruction to the LCD

;	 
		movwf	Temp
		swapf	Temp, W
		andlw	0x0F	
		iorwf		PORTB,f
		iorlw		b'11100000' ; 
		andwf		PORTB,f		
		bsf		_E
		nop
		nop
		nop
		bcf		_E
		movf	Temp, W
		andlw	0x0F
		iorwf		PORTB,f
		iorlw		b'11100000' ; 
		andwf		PORTB,f		
		bsf		_E
		nop
		nop
		nop
		bcf		_E

		call	Delay_200_us1
		return

;----------------------------------------------------------------------;
;    LCD    Line1	;   1-       
;----------------------------------------------------------------------;
Line1
       movlw  0x080                 
       call   SendINS
       movlw  0x00C                  
       call   SendINS
       return

;----------------------------------------------------------------------;
;    LCD    Line2	;   2-                 
;----------------------------------------------------------------------;
Line2
       movlw  0x0C0                 
       call   SendINS
       movlw  0x00C                  
       call   SendINS
       return
;----------------------------------------------------------------------;
CLR_LCD    movlw 0x01 
           call  SendINS ; LCD
		call	Delay_200_us1
       return
;----------------------------------------------------------------------;
;----------------------------------------------------------------------;
CLR_Line
            movlw       .16
            movwf       Count1
CL          movlw " "
            call  SendASCII
         decfsz      	Count1, F
            goto        CL
       return
;----------------------------------------------------------------------;
Text_Metr
       movlw " "
       call  SendASCII
       movlw "M"
       call  SendASCII
       movlw "e"
       call  SendASCII
       movlw "t"
       call  SendASCII
       movlw "r"
       call  SendASCII
       return 
Text_Lx
       movlw " "
       call  SendASCII
       movlw "L"
       call  SendASCII
       movlw "x"
       call  SendASCII
       movlw "-"
       call  SendASCII
       movlw "-"
       call  SendASCII
       movlw "-"
       call  SendASCII
       return 
Text_ERROR
       movlw "C"
       call  SendASCII
       movlw "x"
       call  SendASCII
       movlw " "
       call  SendASCII
       movlw "E"
       call  SendASCII
       movlw "R"
       call  SendASCII
       movlw "R"
       call  SendASCII
       movlw "O"
       call  SendASCII
       movlw "R"
       call  SendASCII

       return 
Text_Cal
       
        movlw "C"
        call  SendASCII
        movlw "a"
        call  SendASCII
        movlw "l"
        call  SendASCII
        movlw "i"
        call  SendASCII
        movlw "b"
        call  SendASCII
        movlw "r"
        call  SendASCII
        movlw "a"
        call  SendASCII
        movlw "t"
        call  SendASCII
        movlw "i"
        call  SendASCII
        movlw "o"
        call  SendASCII
        movlw "n"
        call  SendASCII

	return
Text_save
        movlw "S"
        call  SendASCII
        movlw "a"
        call  SendASCII
        movlw "v"
        call  SendASCII
        movlw "e"
        call  SendASCII
        movlw " "
        call  SendASCII
        movlw "E"
        call  SendASCII
        movlw "E"
        call  SendASCII
        movlw "P"
        call  SendASCII
        movlw "R"
        call  SendASCII
        movlw "O"
        call  SendASCII
        movlw "M"
        call  SendASCII
	return
;----------------------------------------------------------------------;
;                        time delay routines                           ;
;----------------------------------------------------------------------;
 
Delay_200_us1	; 200 
     ;delay = 1'000 machine cycles
;	    movlw       .75
;            movwf       Temp1
;            movlw       .2
;            movwf       Temp2
;L1          decfsz      Temp1, F
;            goto        L1
;            decfsz      Temp2, F
;            goto        L1
;delay = 2'000 machine cycles; 400 
       movlw       .151
            movwf       Temp1
            movlw       .3
            movwf       Temp2
L1          decfsz      Temp1, F
            goto        L1
            decfsz      Temp2, F
            goto        L1
            nop
            nop
		return   
Pause1sek
    ;delay = 4'999'996 machine cycles

            movlw       .109
            movwf       Temp1
            movlw       .94
            movwf       Temp2
            movlw       .26
            movwf       Temp3
L2          decfsz      Temp1, F
            goto        L2
            decfsz      Temp2, F
            goto        L2
            decfsz      Temp3, F
            goto        L2
          	return 
Pause05sek 
;delay = 1'999'996 machine cycles
            movlw       .92
            movwf       Temp1
            movlw       .38
            movwf       Temp2
            movlw       .11
            movwf       Temp3
L3          decfsz      Temp1, F
            goto        L3
            decfsz      Temp2, F
            goto        L3
            decfsz      Temp3, F
            goto        L3
            nop
          	return
;********************************************************************************
;**************   ***************************************
;*** 32 BIT SIGNED SUTRACT ***
;REGA - REGB -> REGA
;Return carry set if overflow

subtract
	call	negateb		;Negate REGB
	skpnc
	return			;Overflow

;*** 32 BIT SIGNED ADD ***
; *** 32   ***
;REGA + REGB -> REGA
;Return carry set if overflow

add	movf	REGA3,w		;Compare signs
	xorwf	REGB3,w
	movwf	MTEMP

	call	addba		;Add REGB to REGA

	clrc			;Check signs
	movf	REGB3,w		;If signs are same
	xorwf	REGA3,w		;so must result sign
	btfss	MTEMP,7		;else overflow
	addlw	0x80
	return

;*** 32 BIT SIGNED MULTIPLY ***
; *** 32   ***
;REGA * REGB -> REGA
;Return carry set if overflow

multiply
	clrf	MTEMP		;Reset sign flag
	call	absa		;Make REGA positive
	skpc
	call	absb		;Make REGB positive
	skpnc
	return			;Overflow

	call	movac		;Move REGA to REGC
	call	clra		;Clear product

	movlw	D'31'		;Loop counter
	movwf	MCOUNT

muloop	call	slac		;Shift left product and multiplicand
	
	rlf	REGC3,w		;Test MSB of multiplicand
	skpnc			;If multiplicand bit is a 1 then
	call	addba		;add multiplier to product

	skpc			;Check for overflow
	rlf	REGA3,w
	skpnc
	return

	decfsz	MCOUNT,f	;Next
	goto	muloop

	btfsc	MTEMP,0		;Check result sign
	call	negatea		;Negative
	return


;*** 32 BIT SIGNED DIVIDE ***
; *** 32  () ***
;REGA3     Hx7F(127).REGA  7f ff ff ff (2 147 483 647)
;  Hx80(128)    

;REGA / REGB -> REGA
;Remainder in REGC
;Return carry set if overflow or division by zero

divide	clrf	MTEMP		;Reset sign flag
	movf	REGB0,w		;Trap division by zero
	iorwf	REGB1,w
	iorwf	REGB2,w
	iorwf	REGB3,w
	sublw	0
	skpc
	call	absa		;Make dividend (REGA) positive
	skpc
	call	absb		;Make divisor (REGB) positive
	skpnc
	return			;Overflow

	clrf	REGC0		;Clear remainder
	clrf	REGC1
	clrf	REGC2
	clrf	REGC3
	call	slac		;Purge sign bit

	movlw	D'31'		;Loop counter
	movwf	MCOUNT

dvloop	call	slac		;Shift dividend (REGA) msb into remainder (REGC)

	movf	REGB3,w		;Test if remainder (REGC) >= divisor (REGB)
	subwf	REGC3,w
	skpz
	goto	dtstgt
	movf	REGB2,w
	subwf	REGC2,w
	skpz
	goto	dtstgt
	movf	REGB1,w
	subwf	REGC1,w
	skpz
	goto	dtstgt
	movf	REGB0,w
	subwf	REGC0,w
dtstgt	skpc			;Carry set if remainder >= divisor
	goto	dremlt

	movf	REGB0,w		;Subtract divisor (REGB) from remainder (REGC)
	subwf	REGC0,f
	movf	REGB1,w
	skpc
	incfsz	REGB1,w
	subwf	REGC1,f
	movf	REGB2,w
	skpc
	incfsz	REGB2,w
	subwf	REGC2,f
	movf	REGB3,w
	skpc
	incfsz	REGB3,w
	subwf	REGC3,f
	clrc
	bsf	REGA0,0		;Set quotient bit

dremlt	decfsz	MCOUNT,f	;Next
	goto	dvloop

	btfsc	MTEMP,0		;Check result sign
	call	negatea		;Negative
	return

;*** ROUND RESULT OF DIVISION TO NEAREST INTEGER ***
; ***         ***
round	clrf	MTEMP		;Reset sign flag
	call	absa		;Make positive
	clrc
	call	slc		;Multiply remainder by 2
	movf	REGB3,w		;Test if remainder (REGC) >= divisor (REGB)
	subwf	REGC3,w
	skpz
	goto	rtstgt
	movf	REGB2,w
	subwf	REGC2,w
	skpz
	goto	dtstgt
	movf	REGB1,w
	subwf	REGC1,w
	skpz
	goto	rtstgt
	movf	REGB0,w
	subwf	REGC0,w
rtstgt	skpc			;Carry set if remainder >= divisor
	goto	rremlt
	incfsz	REGA0,f		;Add 1 to quotient
	goto	rremlt
	incfsz	REGA1,f
	goto	rremlt
	incfsz	REGA2,f
	goto	rremlt
	incf	REGA3,f
	skpnz
	return			;Overflow,return carry set
rremlt	btfsc	MTEMP,0		;Restore sign
	call	negatea
	return


;*** 32 BIT SQUARE ROOT ***
; *** 32    ***
;sqrt(REGA) -> REGA
;Return carry set if negative

sqrt	rlf	REGA3,w		;Trap negative values
	skpnc
	return

	call	movac		;Move REGA to REGC
	call	clrba		;Clear remainder (REGB) and root (REGA)

	movlw	D'16'		;Loop counter
	movwf	MCOUNT

sqloop	rlf	REGC0,f		;Shift two msb's
	rlf	REGC1,f		;into remainder
	rlf	REGC2,f
	rlf	REGC3,f
	rlf	REGB0,f
	rlf	REGB1,f
	rlf	REGB2,f
	rlf	REGC0,f
	rlf	REGC1,f
	rlf	REGC2,f
	rlf	REGC3,f
	rlf	REGB0,f
	rlf	REGB1,f
	rlf	REGB2,f

	setc			;Add 1 to root
	rlf	REGA0,f		;Align root
	rlf	REGA1,f
	rlf	REGA2,f

	movf	REGA2,w		;Test if remdr (REGB) >= root (REGA)
	subwf	REGB2,w
	skpz
	goto	ststgt
	movf	REGA1,w
	subwf	REGB1,w
	skpz
	goto	ststgt
	movf	REGA0,w
	subwf	REGB0,w
ststgt	skpc			;Carry set if remdr >= root
	goto	sremlt

	movf	REGA0,w		;Subtract root (REGA) from remdr (REGB)
	subwf	REGB0,f
	movf	REGA1,w
	skpc
	incfsz	REGA1,w
	subwf	REGB1,f
	movf	REGA2,w
	skpc
	incfsz	REGA2,w
	subwf	REGB2,f
	bsf	REGA0,1		;Set current root bit

sremlt	bcf	REGA0,0		;Clear test bit
	decfsz	MCOUNT,f	;Next
	goto	sqloop

	clrc
	rrf	REGA2,f		;Adjust root alignment
	rrf	REGA1,f
	rrf	REGA0,f
	return


;*** 32 BIT SIGNED BINARY TO DECIMAL ***
; *** 32        
;REGA -> DIGITS 1 (MSD) TO 10 (LSD) & DSIGN
;DSIGN = 0 if REGA is positive, 1 if negative
;Return carry set if overflow
;Uses FSR register

bin2dec	clrf	MTEMP		;Reset sign flag
	call	absa		;Make REGA positive
	skpnc
	return			;Overflow

	call	clrdig		;Clear all digits

	movlw	D'32'		;Loop counter
	movwf	MCOUNT

b2dloop	rlf	REGA0,f		;Shift msb into carry
	rlf	REGA1,f
	rlf	REGA2,f
	rlf	REGA3,f

	movlw	DIGIT10
	movwf	FSR		;Pointer to digits
	movlw	D'10'		;10 digits to do
	movwf	DCOUNT

adjlp	rlf	INDF,f		;Shift digit and carry 1 bit left
	movlw	D'10'
	subwf	INDF,w		;Check and adjust for decimal overflow
	skpnc
	movwf	INDF

	decf	FSR,f		;Next digit
	decfsz	DCOUNT,f
	goto	adjlp

	decfsz	MCOUNT,f	;Next bit
	goto	b2dloop

	btfsc	MTEMP,0		;Check sign
	bsf	DSIGN,0		;Negative
	clrc
	return


;*** 32 BIT SIGNED DECIMAL TO BINARY ***
; *** 32     () ***
;Decimal DIGIT1 thro DIGIT(X) & DSIGN -> REGA
;Set DSIGN = 0 for positive, DSIGN = 1 for negative values
;Most significant digit in DIGIT1
;Enter this routine with digit count in w register
;Return carry set if overflow
;Uses FSR register

dec2bin	movwf	MTEMP		;Save digit count

	movlw	D'32'		;Outer bit loop counter
	movwf	MCOUNT

d2blp1	movlw	DIGIT1-1	;Set up pointer to MSD
	movwf	FSR
	movf	MTEMP,w		;Inner digit loop counter
	movwf	DCOUNT

	movlw	D'10'
	clrc			;Bring in '0' bit into MSD

d2blp2	incf	FSR,f
	skpnc
	addwf	INDF,f		;Add 10 if '1' bit from prev digit
	rrf	INDF,f		;Shift out LSB of digit

	decfsz	DCOUNT,f	;Next L.S. Digit
	goto	d2blp2

	rrf	REGA3,f		;Shift in carry from digits
	rrf	REGA2,f
	rrf	REGA1,f
	rrf	REGA0,f

	decfsz	MCOUNT,f	;Next bit
	goto	d2blp1

	movf	INDF,w		;Check for overflow
	addlw	0xFF
	skpc
	rlf	REGA3,w
	skpnc
	return

	btfsc	DSIGN,0		;Check result sign
	call	negatea		;Negative
	return


;UTILITY ROUTINES


;Add REGB to REGA (Unsigned)
;Used by add, multiply,

addba	movf	REGB0,w		;Add lo byte
	addwf	REGA0,f

	movf	REGB1,w		;Add mid-lo byte
	skpnc			;No carry_in, so just add
	incfsz	REGB1,w		;Add carry_in to REGB
	addwf	REGA1,f		;Add and propagate carry_out

	movf	REGB2,w		;Add mid-hi byte
	skpnc
	incfsz	REGB2,w
	addwf	REGA2,f

	movf	REGB3,w		;Add hi byte
	skpnc
	incfsz	REGB3,w
	addwf	REGA3,f
	return


;Move REGA to REGC
;Used by multiply, sqrt

movac	movf	REGA0,w
	movwf	REGC0
	movf	REGA1,w
	movwf	REGC1
	movf	REGA2,w
	movwf	REGC2
	movf	REGA3,w
	movwf	REGC3
	return


;Clear REGB and REGA
;Used by sqrt

clrba	clrf	REGB0
	clrf	REGB1
	clrf	REGB2
	clrf	REGB3

;Clear REGA
;Used by multiply, sqrt

clra	clrf	REGA0
	clrf	REGA1
	clrf	REGA2
	clrf	REGA3
	return


;Check sign of REGA and convert negative to positive
;Used by multiply, divide, bin2dec, round

absa	rlf	REGA3,w
	skpc
	return			;Positive

;Negate REGA
;Used by absa, multiply, divide, bin2dec, dec2bin, round

negatea	movf	REGA3,w		;Save sign in w
	andlw	0x80

	comf	REGA0,f		;2's complement
	comf	REGA1,f
	comf	REGA2,f
	comf	REGA3,f
	incfsz	REGA0,f
	goto	nega1
	incfsz	REGA1,f
	goto	nega1
	incfsz	REGA2,f
	goto	nega1
	incf	REGA3,f
nega1
	incf	MTEMP,f		;flip sign flag
	addwf	REGA3,w		;Return carry set if -2147483648
	return


;Check sign of REGB and convert negative to positive
;Used by multiply, divide

absb	rlf	REGB3,w
	skpc
	return			;Positive

;Negate REGB
;Used by absb, subtract, multiply, divide

negateb	movf	REGB3,w		;Save sign in w
	andlw	0x80

	comf	REGB0,f		;2's complement
	comf	REGB1,f
	comf	REGB2,f
	comf	REGB3,f
	incfsz	REGB0,f
	goto	negb1
	incfsz	REGB1,f
	goto	negb1
	incfsz	REGB2,f
	goto	negb1
	incf	REGB3,f
negb1
	incf	MTEMP,f		;flip sign flag
	addwf	REGB3,w		;Return carry set if -2147483648
	return


;Shift left REGA and REGC
;Used by multiply, divide, round

slac	rlf	REGA0,f
	rlf	REGA1,f
	rlf	REGA2,f
	rlf	REGA3,f
slc	rlf	REGC0,f
	rlf	REGC1,f
	rlf	REGC2,f
	rlf	REGC3,f
	return


;Set all digits to 0
;Used by bin2dec

clrdig	clrf	DSIGN
	clrf	DIGIT1
	clrf	DIGIT2
	clrf	DIGIT3
	clrf	DIGIT4
	clrf	DIGIT5
	clrf	DIGIT6
	clrf	DIGIT7
	clrf	DIGIT8
	clrf	DIGIT9
	clrf	DIGIT10
	return
;**********************************************************************************
;----------------------------------------------------------------------------------
CH; . 
		movlw       .1
            movwf      	Flags
	    call	CLR_LCD
		btfss		PORTA,Kn_Minus
     	GOTO $-1
CH1    call  Line2
       movlw ">"
       call  SendASCII
       movf  	Flags,0
       addlw "0"
       call  SendASCII
       movlw "<"
       call  SendASCII

            btfsc  PORTA,Kn_Plus
       	GOTO CH2
		incf		Flags,1
			movlw		0x05	
			subwf 	Flags,w	
			btfsc STATUS,Z	      
		      return ;********************
       movlw  0x0C1                 
       call   SendINS
       movf  	Flags,0
       addlw "0"
       call  SendASCII
            btfss  PORTA,Kn_Plus
       	GOTO $-1
CH2
;----------------------------------------------------------------------------------
;   RC0  T=1sek-    \REGA0 \REGA1 \REGA02 \REGA3\ 
 
       call  Count_FHz ;  
;---------------------------------------------------------------------------------- 
	movf A0,W
	movwf REGB0
	movf A1,W
	movwf REGB1
	movf A2,W
	movwf REGB2
	movf A3,W
	movwf REGB3

	movf 	AX,f
	btfss STATUS,Z
		goto	$+3
       call add
		goto	$+2 
       call subtract

       call  Line1
	 call CLR_Line

       call bin2dec     ;  REGA ---> DIGIT
 
;  ------------------------------------------------------------------ 

       call  Line1	;   1- 	
       movlw "F"
       call  SendASCII
       movlw "x"
       call  SendASCII
	movf 	DSIGN,f
	btfss STATUS,Z
		goto	$+4
       movlw " "
       call  SendASCII
		goto	$+3
       movlw "-"
       call  SendASCII
       call  FreqHz     ;  
;----------------------------------------------------------------------------- 
;    EEPROM   .
TABLE_EEPROM ; . 
;  EEPROM 0x30,0x38,0x40,0x48
			movlw		0x08
			movwf		REGB0
			movf Flags,w
			movwf		REGA0
       		call multiply
			movlw		0x28
			movwf		REGB0
       		call	add
			movf REGA0,w
			movwf		Count2
			movwf	A5	;  EEPROM 

		movlw	AX
		movwf	FSR
			movlw		0x05		; 8-
			movwf		Count1
L_C			movf Count2,W
           	call LO_EEPR
		movwf	INDF
		incf	FSR,f

      		incf  Count2,F
			decfsz Count1,F
			goto	L_C

;	AX	;  +00, -02
	movf A0,W
	movwf REGA0
	movf A1,W
	movwf REGA1
	movf A2,W
	movwf REGA2
	movf A3,W
	movwf REGA3
     call bin2dec           ;  REGA ---> DIGIT
		btfss		PORTA,Kn_Minus
     call EDIT_CH
     call DIGIT_CH 
		GOTO CH1
	return

DIGIT_CH ; . 
       call   SendINS
       movlw " "
       call  SendASCII
       call  Pause05sek 

       movlw  0x0C4                 
       call   SendINS
       movf  	AX,0
       addlw "+"
       call  SendASCII

      movf  DIGIT3,0
       addlw "0"
       call  SendASCII
       movf  DIGIT4,0
       addlw "0"
       call  SendASCII
       movlw " "
       call  SendASCII
       movf  DIGIT5,0
       addlw "0"
       call  SendASCII
       movf  DIGIT6,0
       addlw "0"
       call  SendASCII
       movf  DIGIT7,0
       addlw "0"
       call  SendASCII
       movlw " "
       call  SendASCII
       movf  DIGIT8,0
       addlw "0"
       call  SendASCII
       movf  DIGIT9,0
       addlw "0"
       call  SendASCII
       movf  DIGIT10,0
       addlw "0"
       call  SendASCII

       call  Pause05sek 
	return
EDIT_CH; . 
       call Line1
       call CLR_Line
;	AX	;  +00, -02
            btfsc  PORTA,Kn_Plus
		goto $+8 
		movf AX,w
            btfsc STATUS,Z
		goto $+3
			CLRF	AX
		goto $+3
    			movlw  0x02
			movwf	AX

       movlw  0x0C4                 
       call DIGIT_CH
		btfss		PORTA,Kn_Set
	      goto SAVE_CH
   	 btfsc	PORTA,Kn_Minus
		goto EDIT_CH

EDIT_CH1
            btfss  PORTA,Kn_Plus
        	incfsz	DIGIT3,f
    			movlw  0x0A
  			SUBWF DIGIT3,W
			btfsc STATUS,Z
			CLRF	DIGIT3
        movlw  0x0C5 
       call DIGIT_CH
		btfss		PORTA,Kn_Set
	      goto SAVE_CH
	btfsc		PORTA,Kn_Minus
  		goto EDIT_CH1
EDIT_CH2
            btfss  PORTA,Kn_Plus
        	incfsz	DIGIT4,f
    			movlw  0x0A
  			SUBWF DIGIT4,W
			btfsc STATUS,Z
			CLRF	DIGIT4
        movlw  0x0C6 
       call DIGIT_CH
		btfss		PORTA,Kn_Set
	      goto SAVE_CH
	btfsc		PORTA,Kn_Minus
  		goto EDIT_CH2
EDIT_CH3
            btfss  PORTA,Kn_Plus
        	incfsz	DIGIT5,f
    			movlw  0x0A
  			SUBWF DIGIT5,W
			btfsc STATUS,Z
			CLRF	DIGIT5
        movlw  0x0C8 
       call DIGIT_CH
		btfss		PORTA,Kn_Set
	      goto SAVE_CH
	btfsc		PORTA,Kn_Minus
  		goto EDIT_CH3
EDIT_CH4
            btfss  PORTA,Kn_Plus
        	incfsz	DIGIT6,f
    			movlw  0x0A
  			SUBWF DIGIT6,W
			btfsc STATUS,Z
			CLRF	DIGIT6
        movlw  0x0C9 
       call DIGIT_CH
		btfss		PORTA,Kn_Set
	      goto SAVE_CH
	btfsc		PORTA,Kn_Minus
  		goto EDIT_CH4
EDIT_CH5
            btfss  PORTA,Kn_Plus
        	incfsz	DIGIT7,f
    			movlw  0x0A
  			SUBWF DIGIT7,W
			btfsc STATUS,Z
			CLRF	DIGIT7
        movlw  0x0CA 
       call DIGIT_CH
		btfss		PORTA,Kn_Set
	      goto SAVE_CH
	btfsc		PORTA,Kn_Minus
  		goto EDIT_CH5
EDIT_CH6
            btfss  PORTA,Kn_Plus
        	incfsz	DIGIT8,f
    			movlw  0x0A
  			SUBWF DIGIT8,W
			btfsc STATUS,Z
			CLRF	DIGIT8
        movlw  0x0CC 
       call DIGIT_CH
		btfss		PORTA,Kn_Set
	      goto SAVE_CH
	btfsc		PORTA,Kn_Minus
  		goto EDIT_CH6
EDIT_CH7
            btfss  PORTA,Kn_Plus
        	incfsz	DIGIT9,f
    			movlw  0x0A
  			SUBWF DIGIT9,W
			btfsc STATUS,Z
			CLRF	DIGIT9
        movlw  0x0CD 
       call DIGIT_CH
		btfss		PORTA,Kn_Set
	      goto SAVE_CH
	btfsc		PORTA,Kn_Minus
  		goto EDIT_CH7
EDIT_CH8
            btfss  PORTA,Kn_Plus
        	incfsz	DIGIT10,f
    			movlw  0x0A
  			SUBWF DIGIT10,W
			btfsc STATUS,Z
			CLRF	DIGIT10
        movlw  0x0CE 
       call DIGIT_CH
		btfss		PORTA,Kn_Set
	      goto SAVE_CH
	btfsc		PORTA,Kn_Minus
  		goto EDIT_CH8
			return

SAVE_CH	; 
       call Line1
	    call CLR_Line
       call Line1
       call Text_save
       call  Pause05sek 
			CLRF	DIGIT1
			CLRF	DIGIT2
	movlw	D'10'
       call dec2bin
			movf AX,W	;  +00, -02
       		movwf	 Flag_F

			movf A5,W	;  EEPROM 
        		movwf		Count2
			movlw		0x05		; 5-
			movwf		Count1
		movlw	Flag_F
		movwf	FSR

		movf	INDF,W
		movwf TEMP
		movf Count2,W
           	call SAV_EEPR
			incf  FSR,F
			incf  Count2,F
			decfsz Count1,F
			goto		$-7
	return
;*********************************************************************
       END
